# Automarker v2.0
#  Batch download module
# hussein suleman
# 12 march 2010

package Batch;

use Archive::Zip;

use Header;
use User;

sub new 
{
   my ($classname, $cgi, $config, $vula, $userObj) = @_;
   
   my $self = { 
      cgi           => $cgi,
      config        => $config,
      vula          => $vula,
      userObj       => $userObj,
   };
   bless $self, $classname;
   
   return $self;
}

sub batch
{
   my ($self) = @_;

   if ($self->{'userObj'}->checkAdmin == 0) { return; }
   
   if ($self->{'cgi'}->param ('assignment') eq '')
   {
      my $headerObj = new Header ($self->{'cgi'}, $self->{'config'}, $self->{'vula'}, $self->{'userObj'});
      $headerObj->header (); 

      my $output = '<h3>List of Assignments</h3>'.
                   '<table><tr><th>Name</th></tr>';
                
      my @assignmentlist = $self->{'vula'}->getAssignmentList;

      foreach my $assignment (@assignmentlist)
      {
         if (substr ($assignment->{'title'}, -8) ne 'Feedback')
         {
            my $environment = $ENV{QUERY_STRING};
            $environment =~ s/assignment\=[\@\.\_a-zA-Z0-9\+]+//go;
            $environment =~ s/\&+/\&/go;
            $output .= "<tr><td><a href=\"?$environment&assignment=".
                       $assignment->{'title'}."\">".$assignment->{'title'}.
                       "</a></td></tr>";
         }              
      }
      
      $output .= '</table>';
      print $output;
   }
   else
   {
      my $filename = $self->{'cgi'}->param ('assignment').'.zip';
      $filename =~ s/ /_/g;
      print $self->{'cgi'}->header (-type => 'application/zip', -attachment => $filename);
   
      my $zip = new Archive::Zip;

      opendir (my $dir, $self->{'config'}->{'submissionsdir'});
      while (my $user = readdir($dir))
      {
         if (($user ne '.') && ($user ne '..'))
         {
            my $userObj = new User ($self->{'cgi'}, $self->{'config'}, $user, 'Student');
            my @bestAttempt = $userObj->getBestAttempt ($self->{'cgi'}->param ('assignment'));
            if ($#bestAttempt == 2)
            {
               $zip->addDirectory ($user);
               my $submitzip = new Archive::Zip;
               $submitzip->read ($self->{'config'}->{'submissionsdir'}."/$user/".$self->{'cgi'}->param ('assignment')."/$bestAttempt[0]/$bestAttempt[1]");
               foreach my $member ($submitzip->members())
               {
                  my ($contents, $status) = $submitzip->contents ($member->fileName());
                  if ($status ne '') 
                  {
                     $member->fileName ("$user/".$member->fileName());
                     $zip->addMember ($member);
                  }   
               }
            }
         }
      }   
      closedir ($dir);

      $zip->writeToFileHandle (STDOUT, 0);
   }
} 

1;
