# Automarker v2.0
#  Configuration module
# hussein suleman
# 12 march 2010

package Configuration;

sub new
{
   my ($classname) = @_;
   
   my $self = { 
      tee => '/home/automark2/smallfile /usr/bin/tee',

      siteroot => '/home/automark2',
      assignmentsdir => '/home/automark2/assignments',
      submissionsdir => '/home/automark2/submissions',
      markingdir => '/home/automark2/marking',

      mailserver => 'MAIL_SERVER_NAME',
      sakaiurl => 'URL_TO_SAKAI_INSTANCE',
      signedobj => 'SIGNED_OBJECT',
      adminroles => ['Site owner', 'Support staff', 'Lecturer'],
      markerroles => ['Site owner', 'Support staff', 'Lecturer', 'Tutor'],
      penaltyperday => 10,
      timezone => '+0200',
      certfile => '/home/automark2/certs/CERT_FILE',
      helpurl => 'URL_TO_edithelp.html',

      scorerlocation => '/home/automark2/public_html/cgi-bin/scorer.pl',
      
      maximumSubmissions => 10,
      
      logtimeout => 3600,
      logfilename => 'submit.log',
      
      style => '
.headline {
background-color:#FFFFFF;
border-bottom:1px dashed #CCCCCC;
border-top: 0pt;
border-left: 0pt;
border-right: 0pt;
font-family:Verdana,Geneva,Arial,Helvetica,sans-serif;
font-size:0.9em;
line-height:1.5em;
margin:0pt;
padding:0.2em 0pt;
text-align:left; 
white-space:nowrap;
}

.headline a {
background-color:#FFFFFF;
font-family:Verdana,Geneva,Arial,Helvetica,sans-serif;
margin:0pt;
padding:0.2em 0pt;
text-align:left;
display:inline-block;
margin-right:0em;
white-space:nowrap;
color:#0080C0;
text-decoration:none;
}

a:hover, a:active {
color:#0080C0;
text-decoration:underline;
}

table { border: 0; font-size: 1em; }
th { margin: 1pt; padding: 1pt; border: solid 1px; color: white; background: #444444; }
td { vertical-align: top; padding: 2mm; border: solid 1px;}

h1, h2, h3, h4, h5 {
background-color:transparent;
color:#555555;
font-family:Arial,Helvetica,sans-serif;
font-weight:bold;
margin:1em 0pt;
padding:0pt;
}
h3 {
font-size:110%;
}

body {
font-family:'."\'Trebuchet MS\'".',Verdana,Geneva,Arial,Helvetica,sans-serif;
font-size:80%;
}
',
   
   };
   bless $self, $classname;
   
   return $self;
}

1;
