# Automarker v2.0
#  Edit assignments module
# hussein suleman
# 12 march 2010


package Edit;


sub new 
{
   my ($classname, $cgi, $config, $vula, $userObj) = @_;
   
   my $self = { 
      cgi           => $cgi,
      config        => $config,
      vula          => $vula,
      userObj       => $userObj,
   };
   bless $self, $classname;
   
   return $self;
}


sub displayEditList
{
   my ($self) = @_;
   
   my $output = '<h3>List of Assignments</h3>'.
                '<table><tr><th>Name</th></tr>';
             
   my @vulaassignmentlist = $self->{'vula'}->getAssignmentList;

   foreach my $vulaassignment (@vulaassignmentlist)
   {
      my $environment = $ENV{QUERY_STRING};
      $environment =~ s/editedassignment\=[\@\.\_a-zA-Z0-9\+]+//go;
      $environment =~ s/\&+/\&/go;
      $environment =~ s/\&$//go;
      $output .= "<tr><td><a href=\"?$environment&editedassignment=".
                 $vulaassignment->{'title'}."\">".$vulaassignment->{'title'}.
                 "</a></td></tr>";
   }
   
   $output .= '</table>';
   print $output;
}

sub formatForm
{
   my ($self, $title, $markingguide, $manualMarkingTemplate) = @_;
   
   print "<h4>Marking Guide</h4>";
   print "<a href=\"$self->{'config'}->{'helpurl'}\">Documentation on the format of the script</a>";
   $markingguide =~ s/\&/\&amp;/go;
   $manualMarkingTemplate =~ s/\&/\&amp;/go;
   print "<p><form enctype=\"multipart/form-data\" method=\"post\">".
      "<input type=\"hidden\" name=\"action\" value=\"edit\"/>".
      "<input type=\"hidden\" name=\"user\" value=\"".$self->{'cgi'}->param ('user')."\"/>".
      "<input type=\"hidden\" name=\"proxyuser\" value=\"".$self->{'cgi'}->param ('proxyuser')."\"/>".
      "<input type=\"hidden\" name=\"proxyrole\" value=\"".$self->{'cgi'}->param ('proxyrole')."\"/>".
      "<textarea name=\"markingguide\" rows=\"24\" cols=\"80\" wrap=\"off\">$markingguide</textarea>".
      "<h4>Manual Marking Template (fill in for manual marking)</h4>".
      "<textarea name=\"manualmarkingtemplate\" rows=\"24\" cols=\"80\" wrap=\"off\">$manualMarkingTemplate</textarea>".
      "<input type=\"hidden\" name=\"editedassignment\" value=\"$title\"/>".
      "<input type=\"hidden\" name=\"site\" value=\"".$self->{'cgi'}->param ('site')."\"/>".
      "<input type=\"hidden\" name=\"role\" value=\"".$self->{'cgi'}->param ('role')."\"/>".
      "<br/><input type=\"submit\" value=\"Update\"/></form></p>";

   print "<h4>List of Fixed Files</h4>";
  
   my $environment = $ENV{QUERY_STRING};
   $environment =~ s/removefilename\=[\@\.\_a-zA-Z0-9\+]+//go;
   $environment =~ s/download\=[\@\.\_a-zA-Z0-9\+]+//go;
   $environment =~ s/\&+/\&/go;
   $environment =~ s/\&$//go;

   opendir (my $mdir, $self->{'config'}->{'assignmentsdir'}.'/'.$title);
   foreach my $mfile (grep {  ($_ !~ /^\.+$/) && ($_ !~ /^markingguide\.xml/) && ($_ !~ /^markingtemplate\.xml/) } readdir ($mdir))
   {
      print "[<a href=\"?$environment&removefilename=$mfile\">remove</a>]&nbsp;";
      print "<a href=\"?$environment&download=$mfile\">$mfile</a><br/>";
   }
   closedir ($mdir);

   print "<p><form enctype=\"multipart/form-data\" method=\"post\">".
      "<input type=\"hidden\" name=\"action\" value=\"edit\"/>".
      "<input type=\"hidden\" name=\"user\" value=\"".$self->{'cgi'}->param ('user')."\"/>".
      "<input type=\"hidden\" name=\"proxyuser\" value=\"".$self->{'cgi'}->param ('proxyuser')."\"/>".
      "<input type=\"hidden\" name=\"proxyrole\" value=\"".$self->{'cgi'}->param ('proxyrole')."\"/>".
      "Add new file: <input type=\"file\" name=\"fixedfile\"/>".
      "<input type=\"hidden\" name=\"editedassignment\" value=\"$title\"/>".
      "<input type=\"hidden\" name=\"site\" value=\"".$self->{'cgi'}->param ('site')."\"/>".
      "<input type=\"hidden\" name=\"role\" value=\"".$self->{'cgi'}->param ('role')."\"/>".
      "<input type=\"submit\" name=\"upload\" value=\"Upload\"/></form></p>";
}

sub printForm
{
   my ($self) = @_;

   my $title = $self->{'cgi'}->param ('editedassignment');
   print "<h3>Editing $title</h3>";

   open (my $mfile, $self->{'config'}->{'assignmentsdir'}.'/'.$title.'/markingguide.xml');
   my @markingguidelines = <$mfile>;
   close ($mfile);
   my $markingguide = join ('', @markingguidelines);

   open (my $mmfile, $self->{'config'}->{'assignmentsdir'}.'/'.$title.'/markingtemplate.xml');
   my @markingtemplatelines = <$mmfile>;
   close ($mmfile);
   my $manualMarkingTemplate = join ('', @markingtemplatelines);
   
   $self->formatForm ($title, $markingguide, $manualMarkingTemplate);
}

sub checkXML
{
   my ($self, $data) = @_;

   my $tempFilename = '/tmp/automark_xmlcheck'.$$;
   open (my $xfile, '| xmllint --htmlout --noout - > '.$tempFilename.' 2>&1');
   print $xfile $data;
   close ($xfile);
   
   open ($xfile, $tempFilename);
   my $xmlcheck = '';
   while (<$xfile>)
   { $xmlcheck .= $_; }
   close ($xfile);
   unlink $tempFilename;
   
   $xmlcheck = substr ($xmlcheck, 220);
   $xmlcheck = substr ($xmlcheck, 0, length ($xmlcheck)-15);
   
   $xmlcheck;
}

sub checkAndUpdateGuide
{
   my ($self) = @_;

   my $title = $self->{'cgi'}->param ('editedassignment');
   print "<h3>Editing $title</h3>";
   
   my $markingguide = $self->{'cgi'}->param ('markingguide');
   $markingguide =~ s/\r//go;
   my $manualMarkingTemplate = $self->{'cgi'}->param ('manualmarkingtemplate');
   $manualMarkingTemplate =~ s/\r//go;
   
   my $xmlcheck1 = $self->checkXML ($markingguide);
   my $xmlcheck2 = $self->checkXML ($manualMarkingTemplate);
   
   if ((($xmlcheck1 ne '') && ($markingguide ne '')) || 
       (($xmlcheck2 ne '') && ($manualMarkingTemplate ne '')))
   {
      print '<p>There is an error in your XML (as indicated below) - please correct and resubmit.</p>';

      if (($xmlcheck1 ne '') && ($markingguide ne ''))
      { print $xmlcheck1; }
      if (($xmlcheck2 ne '') && ($manualMarkingTemplate ne ''))
      { print $xmlcheck2; }
            
      $self->formatForm ($title, $markingguide, $manualMarkingTemplate);
   }
   else
   {
      mkdir ($self->{'config'}->{'assignmentsdir'}.'/'.$title);
   
      open (my $mfile, '>'.$self->{'config'}->{'assignmentsdir'}.'/'.$title.'/markingguide.xml');
      print $mfile $markingguide;
      close ($mfile);
      open (my $mmfile, '>'.$self->{'config'}->{'assignmentsdir'}.'/'.$title.'/markingtemplate.xml');
      print $mmfile $manualMarkingTemplate;
      close ($mmfile);
      
      print '<p>Saved at '.scalar (localtime()).'</p>';
      $self->formatForm ($title, $markingguide, $manualMarkingTemplate);
   }
}

sub upload
{
   my ($self) = @_;

   my $title = $self->{'cgi'}->param ('editedassignment');

   my $filename = $self->{'cgi'}->param ('fixedfile');
   $filename =~ s/^.*[\/\\]([^\/\\]+)$/$1/;
   my $fh = $self->{'cgi'}->upload ('fixedfile');
      
   my $buffer;
   open (my $out, ">".$self->{'config'}->{'assignmentsdir'}."/$title/$filename");
   while (my $bytesread = read ($fh, $buffer, 1024))
   { print $out $buffer; }
   close ($out);
   
   $self->printForm;   
}

sub download
{
   my ($self) = @_;
   
   my $filename = $self->{'cgi'}->param ('download');
   my $title = $self->{'cgi'}->param ('editedassignment');
      
   print $self->{'cgi'}->header (-type => 'application/octet-stream', -attachment => $filename);
   my $buffer;
   open (my $infile, $self->{'config'}->{'assignmentsdir'}."/$title/$filename");
   while (my $bytesread = read ($infile, $buffer, 1024))
   { print $buffer; }
   close ($infile);
}

sub removeFilename
{
   my ($self) = @_;

   my $title = $self->{'cgi'}->param ('editedassignment');
   my $filename = $self->{'cgi'}->param ('removefilename');
   
   unlink ($self->{'config'}->{'assignmentsdir'}."/$title/$filename");
   
   $self->printForm;   
}

sub edit
{
   my ($self) = @_;

   if ($self->{'userObj'}->checkAdmin == 0) { return; }
   
   if ($self->{'cgi'}->param ('editedassignment') eq '')
   {
      $self->displayEditList;
   }
   elsif ($self->{'cgi'}->param ('upload') ne '')
   {
      $self->upload;
   }
   elsif ($self->{'cgi'}->param ('download') ne '')
   {
      $self->download;
   }
   elsif ($self->{'cgi'}->param ('removefilename') ne '')
   {
      $self->removeFilename;
   }
   elsif (($self->{'cgi'}->param ('markingguide') eq '') &&
          ($self->{'cgi'}->param ('manualmarkingtemplate') eq ''))
   {
      $self->printForm;
   }
   else
   { 
      $self->checkAndUpdateGuide; 
   }
}


1;
