# Automarker v2.0
#  Live logging of submissions
# hussein suleman
# 12 march 2010

package LogStream;

use Header;
use User;

sub new 
{
   my ($classname, $cgi, $config, $vula, $userObj) = @_;
   
   my $self = { 
      cgi           => $cgi,
      config        => $config,
      vula          => $vula,
      userObj       => $userObj,
   };
   bless $self, $classname;
   
   return $self;
}

sub add
{
   my ($self, $event) = @_;
   
   my $stamp = localtime ();
   
   open (my $lfile, ">>".$self->{'config'}->{'submissionsdir'}.'/'.$self->{'config'}->{'logfilename'});
   print $lfile "$stamp : $event\n";
   close ($lfile);
}

sub stream
{
   my ($self) = @_;

   if ($self->{'userObj'}->checkAdmin == 0) { return; }
   
   print "<h3>Event Log</h3><pre>";
   my $lfile;
   
   eval {
      local $SIG{ALRM} = sub { die "alarm\n"; };
      alarm $self->{'config'}->{'logtimeout'};
      
      my $filename = $self->{'config'}->{'submissionsdir'}.'/'.$self->{'config'}->{'logfilename'};
      open ($lfile, $filename);
      
      my @queue = ();
      while (my $aline = <$lfile>)
      {
         if ($#queue > 9)
         { shift (@queue); }
         push (@queue, $aline);
      }
      for ( my $i=0; $i<=$#queue; $i++ )
      {
         print $queue[$i];
      }
      
      while (1)
      {
         select (undef, undef, undef, 0.25);
         while (my $aline = <$lfile>)
         {
            print $aline;
         }
      }   
      alarm 0;
   };
   
   close ($lfile);

   print "</pre><p>Log done ... reload to restart stream</p>";
} 

1;
