# Automarker v2.0
#  Submission of assignments
# hussein suleman
# 12 march 2010

package Submit;

use XML::DOM;
use DateTime::Format::HTTP;
use DateTime::Duration;
use DateTime;

sub new 
{
   my ($classname, $cgi, $config, $vula, $userObj) = @_;
   
   my $self = { 
      cgi           => $cgi,
      config        => $config,
      vula          => $vula,
      userObj       => $userObj,
   };
   bless $self, $classname;
   
   return $self;
}

sub automark
{
   my ($self, $id, $dirid, $filename) = @_;
   
   print "<h3>Marking assignment ...</h3>".
         "<pre>";
   
   umask 0000;
   my $tempdir = '/tmp/automark'.$$;
   mkdir $tempdir, 0777;
   
   system ("\"".$self->{'config'}->{'scorerlocation'}."\" ".
           "\"".$self->{'config'}->{'submissionsdir'}."/".$self->{'userObj'}->{'effectiveUser'}."/$id/$dirid/$filename\" ".
           "\"$tempdir\" ".
           "\"".$self->{'config'}->{'assignmentsdir'}."/$id\"".
           " | ".$self->{'config'}->{'tee'}." \"".$self->{'config'}->{'submissionsdir'}."/".$self->{'userObj'}->{'effectiveUser'}."/$id/$dirid/marking_report.txt\""
          );

   chmod 0710, $self->{'config'}->{'submissionsdir'}."/".$self->{'userObj'}->{'effectiveUser'}."/$id/$dirid/marking_report.txt";

   open (my $scorefile, "$tempdir/score.dat");
   my $score = <$scorefile>;
   $score =~ s/[^0-9]//go;
   close ($scorefile);
   
   system ("rm -fR \"$tempdir\"");

   print "</pre>";

   my $log = new LogStream ($self->{'cgi'}, $self->{'config'}, $self->{'vula'}, $self->{'userObj'});
   $log->add ("Submission [$dirid] for [$id] by [$self->{'userObj'}->{'effectiveUser'}], mark=$score");
         
   $score;
}

sub submit
{
   my ($self) = @_;
   
   my $id = $self->{'cgi'}->param ('id');
   my $fh = $self->{'cgi'}->upload ('submission');
   
   if (defined $fh) 
   {
      umask 0077;
      mkdir $self->{'config'}->{'submissionsdir'}.'/'.$self->{'userObj'}->{'effectiveUser'}, 0700;
      mkdir $self->{'config'}->{'submissionsdir'}.'/'.$self->{'userObj'}->{'effectiveUser'}."/$id", 0700;
   
      my $dirid = 1;
      while (-e $self->{'config'}->{'submissionsdir'}.'/'.$self->{'userObj'}->{'effectiveUser'}."/$id/$dirid")
      { $dirid++; }
      mkdir $self->{'config'}->{'submissionsdir'}.'/'.$self->{'userObj'}->{'effectiveUser'}."/$id/$dirid", 0700;

      my $filename = $self->{'cgi'}->param ('submission');
      $filename =~ s/^.*[\/\\]([^\/\\]+)$/$1/;
      
      my $buffer;
      open (my $out, ">>".$self->{'config'}->{'submissionsdir'}.'/'.$self->{'userObj'}->{'effectiveUser'}."/$id/$dirid/$filename");
      while (my $bytesread = read ($fh, $buffer, 1024))
      { print $out $buffer; }
      close ($out);
      
      # get time before marking starts in case marking takes long
      my $nowTime = DateTime->now ( time_zone => $self->{'config'}->{'timezone'} );

      my $score = $self->automark ($id, $dirid, $filename);
      if ($score eq '') { $score = 0; }
      
      my @vulaassignmentlist = $self->{'vula'}->getAssignmentList;
      
      my $assignmentid = '';
      my $dueTime = DateTime->now ( time_zone => $self->{'config'}->{'timezone'} );
      my $extradays = 0;
      foreach my $assignment (@vulaassignmentlist)
      {
         if ($assignment->{'title'} eq $id)
         {
            $assignmentid = $assignment->{'id'};
            $dueTime = $assignment->{'dueTime'};
         }
      }

      my $assignmentlist = $self->{'userObj'}->readSummary;
      foreach my $assignment (@$assignmentlist)
      {
         if ($assignment->[0] eq $id)
         {
            $extradays = $assignment->[2];
         }
      }

      my $penalty = 0;
      my $extraTime = DateTime::Duration->new ( days => $extradays );
      if (($nowTime - ($dueTime + $extraTime))->is_positive)
      { 
         my $almostoneday = DateTime::Duration->new ( hours=>23, minutes=>59, seconds=>59);
         my $dayslatedur = (($nowTime + $almostoneday) - ($dueTime + $extraTime));
         my $dayslate = $dayslatedur->days + ($dayslatedur->weeks * 7) + ($dayslatedur->months * 30);
         $penalty = $self->{'config'}->{'penaltyperday'} * $dayslate;
      }
      
      if ($penalty > 0)
      { 
         print "Late penalty: $penalty\n\n";
         $score -= $penalty;
         if ($score < 0) { $score = 0; }
         print "Adjusted score: $score\n\n";
      }

      my $newentry = [$self->{'userObj'}->toXML ($filename), $score];
      my $added = 0;
      foreach my $assignment (@$assignmentlist)
      {
         if ($assignment->[0] eq $id)
         {
            push (@{$assignment->[3]}, $newentry);
            $added = 1;
         }
      }
      if ($added == 0)
      { push (@$assignmentlist, [$id, 0, 0, [ $newentry ]]); }
      $self->{'userObj'}->writeSummary ($assignmentlist);
      
      # calculate maximum score
      foreach my $assignment (@$assignmentlist)
      {
         if ($assignment->[0] eq $id)
         {
            foreach my $entry (@{$assignment->[3]})
            {
               while ($entry->[1] > 100)
               {
                  $entry->[1] = sprintf ("%.0f", ($entry->[1] / 10));
               }
               if ($entry->[1] > $score)
               { $score = $entry->[1]; }
            }
         }
      }
      
      if ($assignmentid ne '')
      {
         my $comment = 'Marked automatically by AutoMark';
         $self->{'vula'}->setMarkAndComments ($assignmentid, $self->{'userObj'}, $score, $comment);
      }
   }
   
   (new Manage ($self->{'cgi'}, $self->{'config'}, $self->{'vula'}, $self->{'userObj'}))->assignmentTable ();   
}

1;
