#!/usr/bin/perl

# Automarker v2.0
# hussein suleman
# 12 march 2010

use CGI;

use User;
use Configuration;
use Vula;

use Batch;
use Edit;
use Header;
use LogStream;
use Manage;
use Marking;
use Submit;
use View;


sub main 
{
   my $cgi = new CGI;
   my $config = new Configuration;
   my $vula = new Vula ($cgi, $config);
   my $userObj = new User ($cgi, $config, $cgi->param ('user'), $cgi->param ('role'));
   
   if (! $vula->checkSakai)
   {
      print "Content-type: text/html\n\nNot authenticated/connected to Sakai instance.\n";
      exit;
   }
   
   if (! -e $config->{'siteroot'}.'/'.$cgi->param ('site'))
   {
      mkdir ($config->{'siteroot'}.'/'.$cgi->param ('site'));
      mkdir ($config->{'siteroot'}.'/'.$cgi->param ('site').'/assignments');
      mkdir ($config->{'siteroot'}.'/'.$cgi->param ('site').'/marking');
      mkdir ($config->{'siteroot'}.'/'.$cgi->param ('site').'/submissions');
   }
   $config->{'submissionsdir'} = $config->{'siteroot'}.'/'.$cgi->param ('site').'/submissions';
   $config->{'assignmentsdir'} = $config->{'siteroot'}.'/'.$cgi->param ('site').'/assignments';
   $config->{'markingdir'} = $config->{'siteroot'}.'/'.$cgi->param ('site').'/marking';
   
   if ($cgi->param ('action') eq 'submit')
   { 
      (new Header ($cgi, $config, $vula, $userObj))->header ();
      (new Submit ($cgi, $config, $vula, $userObj))->submit ();
   }
   elsif ($cgi->param ('action') eq 'edit')
   {
      if ($cgi->param ('download') eq '')
      { (new Header ($cgi, $config, $vula, $userObj))->header (); }
      (new Edit ($cgi, $config, $vula, $userObj))->edit (); 
   }
   elsif ($cgi->param ('action') eq 'explode')
   {
      (new View ($cgi, $config, $vula, $userObj))->explode (); 
   }
   elsif ($cgi->param ('action') eq 'download')
   {
      (new View ($cgi, $config, $vula, $userObj))->download (); 
   }
   elsif ($cgi->param ('action') eq 'viewreport')
   {
      (new Header ($cgi, $config, $vula, $userObj))->header (); 
      (new View ($cgi, $config, $vula, $userObj))->viewreport (); 
   }
   elsif ($cgi->param ('action') eq 'viewfeedback')
   {
      (new Header ($cgi, $config, $vula, $userObj))->header (); 
      (new Marking ($cgi, $config, $vula, $userObj))->viewFeedback (); 
   }
   elsif ($cgi->param ('action') eq 'updateextras')
   { 
      (new Header ($cgi, $config, $vula, $userObj))->header (); 
      (new Manage ($cgi, $config, $vula, $userObj))->updateExtras (); 
   }
   elsif ($cgi->param ('action') eq 'manage')
   {
      (new Header ($cgi, $config, $vula, $userObj))->header (); 
      (new Manage ($cgi, $config, $vula, $userObj))->assignmentTable (); 
   }
   elsif ($cgi->param ('action') eq 'managelist')
   {
      (new Header ($cgi, $config, $vula, $userObj))->header (); 
      (new Manage ($cgi, $config, $vula, $userObj))->manageList (); 
   }
   elsif ($cgi->param ('action') eq 'marking')
   {
      (new Header ($cgi, $config, $vula, $userObj))->header (); 
      (new Marking ($cgi, $config, $vula, $userObj))->marking (); 
   }
   elsif ($cgi->param ('action') eq 'reviewmarking')
   {
      (new Header ($cgi, $config, $vula, $userObj))->header (); 
      (new Marking ($cgi, $config, $vula, $userObj))->reviewmarking (); 
   }
   elsif ($cgi->param ('action') eq 'batch')
   {
      (new Batch ($cgi, $config, $vula, $userObj))->batch (); 
   }
   elsif ($cgi->param ('action') eq 'logstream')
   {
      (new Header ($cgi, $config, $vula, $userObj))->header (); 
      (new LogStream ($cgi, $config, $vula, $userObj))->stream (); 
   }
   else
   { 
      (new Header ($cgi, $config, $vula, $userObj))->header ();
      (new Manage ($cgi, $config, $vula, $userObj))->assignmentTable (); 
   }

   if (($cgi->param ('action') ne 'download') &&
      ($cgi->param ('action') ne 'batch'))
   { print "</body></html>"; }
}

$| = 1;
main;

