#!/usr/bin/perl
#
# rebuild the summary.xml for a given student in a given class
# hussein
# 28 august 2009
#
# usage: rebuildsummary.pl <course_id> <studentid>

use XML::DOM;

#open (my $summary, ">$ARGV[0]/submissions/$ARGV[1]/summary.xml");
open (my $summary, ">summary.xml");
print $summary "<assignments>\n";

opendir (my $student, "$ARGV[0]/submissions/$ARGV[1]");
foreach my $assignment (grep { /[^.]+/ } readdir ($student))
{
   if (-d "$ARGV[0]/submissions/$ARGV[1]/$assignment")
   {
      print $summary "   <assignment>\n";
      print $summary "      <id>$assignment</id>\n";
      print $summary "      <extratries>0</extratries>\n";
      print $summary "      <extradays>0</extradays>\n";
   
      opendir (my $assignmentdir, "$ARGV[0]/submissions/$ARGV[1]/$assignment");
      foreach my $attempt (grep { /[^.]+/ } readdir ($assignmentdir))
      {
         print $summary "      <attempt>\n";
         
         opendir (my $attemptdir, "$ARGV[0]/submissions/$ARGV[1]/$assignment/$attempt");
         foreach my $filename (grep { /[^.]+/ } readdir ($attemptdir))
         {
            my $mark = -1;
            if ($filename eq 'marking_report.txt')
            {
               open (my $markingreport, "$ARGV[0]/submissions/$ARGV[1]/$assignment/$attempt/$filename");
               $/=null;
               my $data = <$markingreport>;
               close ($markingreport);
               
               if ($data =~ /Total marks for assignment: ([0-9]+)/)
               {
                  $mark = $1;
               }
               
               if (mark > -1)
               { print $summary "         <score>$mark</score>\n"; }
            }
            else
            {
               print $summary "         <filename>$filename</filename>\n";
            }   
         }   
         
         print $summary "      </attempt>\n";         
         closedir ($attemptdir)         
      }
      
      print $summary "   </assignment>\n";
      closedir ($assignmentdir)
   }
}

closedir ($student);
   
print $summary "</assignments>\n";
close ($summary);   
   
